package sequences;

public enum AminoAcid {
//AminoAcid (charge, hydrophobicity - ECS, small, tiny, branched side chain)
	A (0, .62, 1, 1, 0),
	B (-.5, -.84, 1, 0, 0),
	C (0, .29, 1, 0, 0),
	D (-1, -.9, 1, 0, 0),
	E (-1, -.74, 0, 0, 0),
	F (0, 1.2, 0, 0, 0),
	G (0, .48, 1, 1, 0),
	H (1, -.4, 0, 0, 0), 
	I (0, 1.4, 0, 0, 1),
	J (0, 1.25, 0, 0, 1),
	K (1, -1.5, 0, 0, 0),
	L (0, 1.1, 0, 0, 1),
	M (0, .64, 0, 0, 0),
	N (0, -.78, 1, 0, 0), 
	P (0, .12, 1, 0, 0),
	Q (0, -.85, 0, 0, 0), 
	R (1, -2.5, 0, 0, 0), 
	S (0, -.18, 1, 1, 0),
	T (0, -.05, 1, 0, 0),
	V (0, 1.1, 1, 0, 1), 
	W (0, .81, 0, 0, 0),
	X (.05, .006, .45, .15, .15),
	Y (0, .26, 0, 0, 0),
	Z (-.5, -.795, 0, 0, 0);
	
	double charge;
	double hydrophobicity;
	double small;
	double tiny;
	double branchedSideChain;
	
	private static AminoAcid[] standardValues = {AminoAcid.A, AminoAcid.C, AminoAcid.D, AminoAcid.E,
			AminoAcid.F, AminoAcid.G, AminoAcid.H, AminoAcid.I, AminoAcid.K, AminoAcid.L,
			AminoAcid.M, AminoAcid.N, AminoAcid.P, AminoAcid.Q, AminoAcid.R, AminoAcid.S,
			AminoAcid.T, AminoAcid.V, AminoAcid.W, AminoAcid.Y};
	
	AminoAcid(double charge, double hydrophobicity, double small, double tiny, double branched) {
		this.charge = charge;
		this.hydrophobicity = hydrophobicity;
		this.small = small;
		this.tiny = tiny;
		this.branchedSideChain = branched;
	}
	
	public static AminoAcid[] standardValues() {
		return standardValues;
	}

	public double charge() {
		return charge;
	}
	
	public double hydrophobicity() {
		return hydrophobicity;
	}
	
	public double small() {
		return small;
	}
	
	public double tiny() {
		return tiny;
	}
	
	public double branchedSideChain() {
		return branchedSideChain;
	}
	
	public boolean nonStandard() {
		return (this == AminoAcid.B || this == AminoAcid.J || this == AminoAcid.Z || this == AminoAcid.X);
	}
}