package sequences;



/*
 * Each coil residue is a pair: the label denoting which part of the heptad
 * it belongs to, as well as the amino acid residue
 */
public class CoilResidue extends Residue {
	Heptad heptadPosition;
	CoilType type;
	
	public CoilResidue(CoilType type, AminoAcid residue, Heptad heptadPosition) {
		super(residue);
		this.type = type;
		this.heptadPosition = heptadPosition;
	}
	
	public Heptad getHept() {
		return heptadPosition;
	}
	
	public CoilType type() {
		return type;
	}
}