package sequences;


/**
 * A CoilState contains a heptad (a-g), a pos (ONE, TWO...) and isCoil
 * (a boolean for whether it's a CC state or non-CC state
 * @author jtrigg
 *
 */
public class CoilState {
	String name;
	public Heptad hept;
	public Pos pos;
	public CoilType type;
	
	/**
	 * isCoil true constructor - note you need to enter a Heptad
	 * @param name
	 * @param hept - NOTE: the heptad doesn't matter if isCoil is false
	 * @param pos
	 * @param isCoil
	 */
	public CoilState(String name, Heptad hept, Pos pos, CoilType type) {
		this.name = name; 
		this.hept = hept;
		this.pos = pos;
		this.type = type;
	}
	
	/**
	 * isCoil false constructor - no Heptad entered
	 * @param name
	 * @param pos
	 */
	public CoilState(String name, Pos pos, CoilType type) {
		this.name = name;
		this.pos = pos;
		this.type = type;
	}

	public Heptad heptad() {
		return hept;
	}
	
	public Pos position() {
		return pos;
	}
	
	public CoilType getCoilType() {
		return type;
	}
	
	
	public String toString() {
		return this.name;
	}

}
