package sequences;

import java.util.ArrayList;

public class Family {
	String name;
	ArrayList<Sequence> seqs;
	ArrayList<CoiledCoil> coils;
	CoilType type;

	public Family(String name, ArrayList<Sequence> cs, CoilType type) {
		this.name = name;
		seqs = cs;
		this.type = type;
	}

	public Family(String name, CoilType type) {
		this.name = name;
		seqs = new ArrayList<Sequence>();
		this.type = type;
	}

	public ArrayList<Sequence> getSeqs() {
		return seqs;
	}

	public Family add(Sequence toAdd) {
		seqs.add(toAdd);
		return this;
	}

	public Family add(Family toAdd) {
		for(Sequence seq: toAdd.getSeqs()) {
			seqs.add(seq);
		}
		return this;
	}

	public ArrayList<CoiledCoil> famToCoils() {
		//the first time, initialize the coils field:
		if(coils == null) {
			ArrayList<CoiledCoil> result = new ArrayList<CoiledCoil>();
			for(Sequence seq: seqs) {
				result.addAll(seq.toCoils());
			}
			coils = result;
		}
		return coils;
	}

	public static ArrayList<CoiledCoil> familyListToCoils(ArrayList<Family> familyList) {
		ArrayList<CoiledCoil> result = new ArrayList<CoiledCoil>();
		for(Family f: familyList) {
			result.addAll(f.famToCoils());
		}
		return result;
	}

	@Override
	public String toString() {
		return type + "_" + name;
	}
	
	public String name() {
		return name;
	}
	
	public CoilType type() {
		return type;
	}
}