package sequences;
/**
 * Coiled Coils have a distinctive pattern of period 7
 * the Heptad enum names each position (a-g)
 * @author jtrigg
 *
 */

public enum Heptad {
 a {
	public Heptad prev() {return Heptad.g;} 
 },
 b {
	public Heptad prev() {return Heptad.a;} 
 },
 c {
	public Heptad prev() {return Heptad.b;} 
 },
 d {
	 public Heptad prev() {return Heptad.c;} 	 
 },
 e {
	public Heptad prev() {return Heptad.d;} 	 
 },
 f {
	public Heptad prev() {return Heptad.e;} 	  
 },
 g {
	public Heptad prev() {return Heptad.f;} 	 
 };
 
 
 //Returns the previous heptad
 public abstract Heptad prev();
 
 //Go back by i heptads
 public Heptad prev(int i) {
	 if(i <= 0) {
		 return this;
	 } else {
		 return this.prev().prev(i-1);
	 }
 }
}
