package sequences;


/**
 * Position of an HMM. The positions represents which number residue of the
 * current CC or nonCC sequence we are on. ONE represents the first residue, etc.
 * @author jtrigg
 *
 */
public enum Pos {
	ONE   {public String toString() {return "1";}
	public int toInt() {return 1;}
	public Pos next() {return TWO;}
	public boolean lastState() {return false;}
	public boolean canLeave() {return false;}
	},
	TWO   {public String toString() {return "2";}
	public int toInt() {return 2;}
	public Pos next() {return THREE;}
	public boolean lastState() {return false;}
	public boolean canLeave() {return false;}
	},
	THREE {public String toString() {return "3";}
	public int toInt() {return 3;}
	public Pos next() {return FOUR;}	
	public boolean lastState() {return false;}
	public boolean canLeave() {return false;}
	},
	FOUR  {public String toString() {return "4";}
	public int toInt() {return 4;}
	public Pos next() {return FIVE;}	
	public boolean lastState() {return false;}
	public boolean canLeave() {return false;}
	},
	FIVE  {public String toString() {return "5";}
	public int toInt() {return 5;}
	public Pos next() {return SIX;}	
	public boolean lastState() {return false;}
	public boolean canLeave() {return false;}
	},
	SIX   {public String toString() {return "6";}
	public int toInt() {return 6;}
	public Pos next() {return SEVEN;}	
	public boolean lastState() {return false;}
	public boolean canLeave() {return false;}
	},
	SEVEN {public String toString() {return "7";}
	public int toInt() {return 7;}
	public Pos next() {return EIGHT;}	
	public boolean lastState() {return false;}
	public boolean canLeave() {return false;}
	},
	//To switch to nine state mode (to 21 state mode):
	//EIGHT.next() = EIGHT (NINE)
	//NINE.next() = ONE (TEN)
	//NINE.lastState() = true (false)
	//Pos.max = 9 (21)
	EIGHT {public String toString() {return "8";}
	public int toInt() {return 8;}
	public Pos next() {return EIGHT;}
	public boolean lastState() {return false;}
	public boolean canLeave() {return false;}
	},
	NINE  {public String toString() {return "9";}
	public int toInt() {return 9;}
	public Pos next() {return ONE;}
	public boolean lastState() {return true;}
	public boolean canLeave() {return true;}
	};
	

	public abstract int toInt();
	public abstract String toString();
	public abstract Pos next();
	public abstract boolean lastState();
	public abstract boolean canLeave();
	
	public static int max() {
		return 9;}
	public boolean secondLast() {
		return (this == this.next());
	}
}
